import { Injectable, ɵɵdefineInjectable, Component, NgModule, EventEmitter, Input, Output, ComponentFactoryResolver, ApplicationRef, Injector, ɵɵinject, INJECTOR, Directive, ViewContainerRef, ContentChildren, ViewChild, TemplateRef, ChangeDetectorRef, Inject } from '@angular/core';
import { CommonModule, DOCUMENT } from '@angular/common';
import { NgbCalendar, NgbDatepickerConfig, NgbModule, NgbDropdownModule } from '@ng-bootstrap/ng-bootstrap';
import { FormsModule } from '@angular/forms';
import { __values } from 'tslib';
import { Subject, BehaviorSubject } from 'rxjs';
import { ColorPickerModule } from 'ngx-color-picker';
import { RouterModule } from '@angular/router';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxTruUiService = /** @class */ (function () {
    function NgxTruUiService() {
    }
    NgxTruUiService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    NgxTruUiService.ctorParameters = function () { return []; };
    /** @nocollapse */ NgxTruUiService.ngInjectableDef = ɵɵdefineInjectable({ factory: function NgxTruUiService_Factory() { return new NgxTruUiService(); }, token: NgxTruUiService, providedIn: "root" });
    return NgxTruUiService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxTruUiComponent = /** @class */ (function () {
    function NgxTruUiComponent() {
    }
    /**
     * @return {?}
     */
    NgxTruUiComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    NgxTruUiComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-tru-ngx-tru-ui',
                    template: "\n    <p>\n      ngx-tru-ui works!\n    </p>\n  "
                }] }
    ];
    /** @nocollapse */
    NgxTruUiComponent.ctorParameters = function () { return []; };
    return NgxTruUiComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxTruUiModule = /** @class */ (function () {
    function NgxTruUiModule() {
    }
    NgxTruUiModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [NgxTruUiComponent],
                    imports: [],
                    exports: [NgxTruUiComponent]
                },] }
    ];
    return NgxTruUiModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TruDatePickerComponent = /** @class */ (function () {
    function TruDatePickerComponent(calendar, config) {
        this.calendar = calendar;
        this.config = config;
        this.navigation = 'select';
        this.disableWeekend = false;
        this.showWeekNumbers = true;
        this.outsideDays = 'visible';
        this.getSelectedDate = new EventEmitter();
    }
    /**
     * @return {?}
     */
    TruDatePickerComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        console.log(this.disableWeekend);
        if (this.disableWeekend) {
            this.config.markDisabled = (/**
             * @param {?} date
             * @return {?}
             */
            function (date) { return _this.calendar.getWeekday(date) >= 6; });
        }
    };
    /**
     * @return {?}
     */
    TruDatePickerComponent.prototype.getDate = /**
     * @return {?}
     */
    function () {
        this.getSelectedDate.emit(this.datePicker);
    };
    TruDatePickerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-tru-date-picker',
                    template: "<div class=\"input-group \">\n  <input class=\"form-control with-append \" placeholder=\"yyyy-mm-dd\"\n         [name]=\"datePickerId\"\n         [id]=\"datePickerId\"\n         [(ngModel)]=\"datePicker\"\n         ngbDatepicker #d=\"ngbDatepicker\"\n         (click)=\"d.toggle()\"\n         (dateSelect) = \"getDate()\"\n         [maxDate] = \"maxDate\"\n         [minDate]=\"minDate\"\n         [navigation]=\"navigation\"\n         [outsideDays]=\"outsideDays\"\n         >\n  <div class=\"input-group-append bg-white\">\n    <button class=\"btn btn-link \" (click)=\"d.toggle()\" type=\"button\"><i class=\"fa fa-calendar\"></i></button>\n  </div>\n</div>\n",
                    styles: [".input-group-append{border:1px solid #ced4da;border-left:0!important}"]
                }] }
    ];
    /** @nocollapse */
    TruDatePickerComponent.ctorParameters = function () { return [
        { type: NgbCalendar },
        { type: NgbDatepickerConfig }
    ]; };
    TruDatePickerComponent.propDecorators = {
        datePickerId: [{ type: Input }],
        navigation: [{ type: Input }],
        disableWeekend: [{ type: Input }],
        showWeekNumbers: [{ type: Input }],
        outsideDays: [{ type: Input }],
        maxDate: [{ type: Input }],
        minDate: [{ type: Input }],
        getSelectedDate: [{ type: Output }]
    };
    return TruDatePickerComponent;
}());
if (false) {
    /** @type {?} */
    TruDatePickerComponent.prototype.datePicker;
    /** @type {?} */
    TruDatePickerComponent.prototype.datePickerId;
    /** @type {?} */
    TruDatePickerComponent.prototype.navigation;
    /** @type {?} */
    TruDatePickerComponent.prototype.disableWeekend;
    /** @type {?} */
    TruDatePickerComponent.prototype.showWeekNumbers;
    /** @type {?} */
    TruDatePickerComponent.prototype.outsideDays;
    /** @type {?} */
    TruDatePickerComponent.prototype.maxDate;
    /** @type {?} */
    TruDatePickerComponent.prototype.minDate;
    /** @type {?} */
    TruDatePickerComponent.prototype.getSelectedDate;
    /**
     * @type {?}
     * @private
     */
    TruDatePickerComponent.prototype.calendar;
    /**
     * @type {?}
     * @private
     */
    TruDatePickerComponent.prototype.config;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TruDatePickerModule = /** @class */ (function () {
    function TruDatePickerModule() {
    }
    TruDatePickerModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [TruDatePickerComponent],
                    imports: [
                        CommonModule,
                        FormsModule,
                        NgbModule
                    ],
                    exports: [CommonModule, TruDatePickerComponent, NgbModule],
                    entryComponents: [TruDatePickerComponent]
                },] }
    ];
    return TruDatePickerModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DragAndDropComponent = /** @class */ (function () {
    function DragAndDropComponent() {
        this.fileToUpload = [];
        this.dragEnter = false;
        this.currentInput = 0;
        this.singleFile = '';
        this.type = 'multiple';
        this.getAddedFiles = new EventEmitter();
    }
    /**
     * @return {?}
     */
    DragAndDropComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @param {?} files
     * @return {?}
     */
    DragAndDropComponent.prototype.uploadFile = /**
     * @param {?} files
     * @return {?}
     */
    function (files) {
        if (this.type === 'single') {
            this.fileToUpload = [];
            this.fileToUpload.push(files.item(0));
            this.singleFile = files.item(0).name;
            this.getAddedFiles.emit(this.fileToUpload);
        }
        else {
            console.log(this.fileToUpload);
            for (var singleFile = 0; singleFile < files.length; singleFile++) {
                this.singleFile = files.item(singleFile).name;
                this.fileToUpload.push(files.item(singleFile));
                this.getAddedFiles.emit(this.fileToUpload);
            }
        }
    };
    /**
     * @param {?} item
     * @param {?} ev
     * @return {?}
     */
    DragAndDropComponent.prototype.removeFile = /**
     * @param {?} item
     * @param {?} ev
     * @return {?}
     */
    function (item, ev) {
        this.singleFile = '';
        ev.preventDefault();
        console.log(item);
        for (var deleteItem in this.fileToUpload) {
            if (this.fileToUpload[deleteItem] === item) {
                this.fileToUpload.splice(+deleteItem, 1);
                this.getAddedFiles.emit(this.fileToUpload);
            }
        }
    };
    /**
     * @param {?} ev
     * @return {?}
     */
    DragAndDropComponent.prototype.dropHandler = /**
     * @param {?} ev
     * @return {?}
     */
    function (ev) {
        var e_1, _a;
        // Prevent default behavior (Prevent file from being opened)
        ev.preventDefault();
        if (ev.dataTransfer.items) {
            // Use DataTransferItemList interface to access the file(s)
            /** @type {?} */
            var data = ev.dataTransfer.items;
            try {
                for (var data_1 = __values(data), data_1_1 = data_1.next(); !data_1_1.done; data_1_1 = data_1.next()) {
                    var i = data_1_1.value;
                    if (i.kind === 'file') {
                        /** @type {?} */
                        var file = i.getAsFile();
                        this.singleFile = file.name;
                        this.fileToUpload.push(file);
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (data_1_1 && !data_1_1.done && (_a = data_1.return)) _a.call(data_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
    };
    /**
     * @param {?} ev
     * @return {?}
     */
    DragAndDropComponent.prototype.dragOverHandler = /**
     * @param {?} ev
     * @return {?}
     */
    function (ev) {
        ev.preventDefault();
    };
    DragAndDropComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-tru-drag-and-drop',
                    template: "<div  class=\"w-100\">\n  <label class=\"drag-drop-container w-100\"\n         (drop)=\"dropHandler($event); dragEnter = false\" (dragover)=\"dragOverHandler($event); dragEnter = true\" (dragend)=\"dragEnter = false\"  for=\"{{name}}\">\n    <span *ngIf=\"singleFile !== '' && type === 'single'\" style=\"z-index: 11;\">\n      {{singleFile}}\n      <a style=\"z-index: 11;\" (click)=\"removeFile(0, $event)\"><i class=\"fa fa-trash\"></i></a>\n    </span>\n\n    <div *ngIf=\"type === 'multiple' \">\n      <span *ngIf=\"dragEnter\">Drop Here</span>\n      <span *ngIf=\"!dragEnter\">\n        <i class=\"fa fa-image\"></i>\n        Drag files here or\n        <a class=\"btn-link\">Browse</a>\n      </span>\n      <small>JPG, PNG and 2 MB Max, 728 X 90</small>\n    </div>\n    <div *ngIf=\"type === 'single' && singleFile === '' \">\n      <span *ngIf=\"dragEnter\">Drop Here</span>\n      <span *ngIf=\"!dragEnter\">\n        <i class=\"fa fa-image\"></i>\n        Drag files here or\n        <a class=\"btn-link\">Browse</a>\n      </span>\n      <small>JPG, PNG and 2 MB Max, 728 X 90</small>\n    </div>\n\n  </label>\n  <input [multiple]=\"type === 'multiple'\"\n         (change)=\" uploadFile($event.target.files)\"\n         type=\"file\" class=\"d-none\"\n         id=\"{{name}}\" />\n\n         <table  class=\"tru-light-table w-100 pt-2\" *ngIf=\"type == 'multiple' && fileToUpload.length > 0\">\n            <thead>\n            <tr>\n              <th>name</th>\n              <th>size</th>\n              <th>type</th>\n              <th>remove</th>\n            </tr>\n            </thead>\n            <tbody>\n            <tr *ngFor=\"let file of fileToUpload; let i = index\">\n              <td>{{file.name}}</td>\n              <td>{{file.size}}</td>\n              <td>{{file.type}}</td>\n              <td><a (click)=\"removeFile(file, $event)\"><i class=\"fa fa-trash\"></i></a></td>\n            </tr>\n            </tbody>\n          </table>\n\n</div>\n\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    DragAndDropComponent.ctorParameters = function () { return []; };
    DragAndDropComponent.propDecorators = {
        type: [{ type: Input }],
        name: [{ type: Input }],
        getAddedFiles: [{ type: Output }]
    };
    return DragAndDropComponent;
}());
if (false) {
    /** @type {?} */
    DragAndDropComponent.prototype.fileToUpload;
    /** @type {?} */
    DragAndDropComponent.prototype.dragEnter;
    /** @type {?} */
    DragAndDropComponent.prototype.currentInput;
    /** @type {?} */
    DragAndDropComponent.prototype.singleFile;
    /** @type {?} */
    DragAndDropComponent.prototype.type;
    /** @type {?} */
    DragAndDropComponent.prototype.name;
    /** @type {?} */
    DragAndDropComponent.prototype.getAddedFiles;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template D
 */
var  /**
 * @template D
 */
Dragndrop = /** @class */ (function () {
    function Dragndrop() {
    }
    return Dragndrop;
}());
if (false) {
    /** @type {?} */
    Dragndrop.prototype.data;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DragndropRef = /** @class */ (function () {
    function DragndropRef() {
        this.dragndropFiles = new Subject();
        this.dragnDropFiles = this.dragndropFiles.asObservable();
    }
    /**
     * @param {?=} result
     * @return {?}
     */
    DragndropRef.prototype.results = /**
     * @param {?=} result
     * @return {?}
     */
    function (result) {
        this.dragndropFiles.next(result);
    };
    return DragndropRef;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    DragndropRef.prototype.dragndropFiles;
    /** @type {?} */
    DragndropRef.prototype.dragnDropFiles;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DragndropInjector = /** @class */ (function () {
    function DragndropInjector(parentInjector, additionalTokens) {
        this.parentInjector = parentInjector;
        this.additionalTokens = additionalTokens;
    }
    /**
     * @param {?} token
     * @param {?=} notFoundValue
     * @param {?=} flags
     * @return {?}
     */
    DragndropInjector.prototype.get = /**
     * @param {?} token
     * @param {?=} notFoundValue
     * @param {?=} flags
     * @return {?}
     */
    function (token, notFoundValue, flags) {
        /** @type {?} */
        var value = this.additionalTokens.get(token);
        if (value) {
            return value;
        }
        return this.parentInjector.get(token, notFoundValue);
    };
    return DragndropInjector;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    DragndropInjector.prototype.parentInjector;
    /**
     * @type {?}
     * @private
     */
    DragndropInjector.prototype.additionalTokens;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DragAndDropService = /** @class */ (function () {
    function DragAndDropService(componentFactoryResolver, appRef, injector) {
        this.componentFactoryResolver = componentFactoryResolver;
        this.appRef = appRef;
        this.injector = injector;
        this.addeddragndrops = [];
    }
    /**
     * @param {?} position
     * @param {?=} dragndropConfig
     * @return {?}
     */
    DragAndDropService.prototype.appendDragndropComponentToBody = /**
     * @param {?} position
     * @param {?=} dragndropConfig
     * @return {?}
     */
    function (position, dragndropConfig) {
        /** @type {?} */
        var map = new WeakMap();
        map.set(Dragndrop, dragndropConfig);
        /** @type {?} */
        var dragndropRef = new DragndropRef();
        map.set(DragndropRef, dragndropRef);
        /** @type {?} */
        var componentFactory = this.componentFactoryResolver.resolveComponentFactory(DragAndDropComponent);
        /** @type {?} */
        var componentRef = componentFactory.create(new DragndropInjector(this.injector, map));
        this.appRef.attachView(componentRef.hostView);
        /** @type {?} */
        var domElem = (/** @type {?} */ (((/** @type {?} */ (componentRef.hostView))).rootNodes[0]));
        document.getElementById(position).appendChild(domElem);
        this.dragndropComponentRef = componentRef;
        return dragndropRef;
    };
    /**
     * @param {?} si
     * @param {?} ty
     * @param {?} pos
     * @return {?}
     */
    DragAndDropService.prototype.addDragndrop = /**
     * @param {?} si
     * @param {?} ty
     * @param {?} pos
     * @return {?}
     */
    function (si, ty, pos) {
        /** @type {?} */
        var config = { data: { size: si, type: ty, position: pos } };
        /** @type {?} */
        var dragndropRef = this.appendDragndropComponentToBody(pos, config);
        return dragndropRef;
    };
    DragAndDropService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    DragAndDropService.ctorParameters = function () { return [
        { type: ComponentFactoryResolver },
        { type: ApplicationRef },
        { type: Injector }
    ]; };
    /** @nocollapse */ DragAndDropService.ngInjectableDef = ɵɵdefineInjectable({ factory: function DragAndDropService_Factory() { return new DragAndDropService(ɵɵinject(ComponentFactoryResolver), ɵɵinject(ApplicationRef), ɵɵinject(INJECTOR)); }, token: DragAndDropService, providedIn: "root" });
    return DragAndDropService;
}());
if (false) {
    /** @type {?} */
    DragAndDropService.prototype.dragndropComponentRef;
    /** @type {?} */
    DragAndDropService.prototype.clear;
    /** @type {?} */
    DragAndDropService.prototype.addeddragndrops;
    /**
     * @type {?}
     * @private
     */
    DragAndDropService.prototype.componentFactoryResolver;
    /**
     * @type {?}
     * @private
     */
    DragAndDropService.prototype.appRef;
    /**
     * @type {?}
     * @private
     */
    DragAndDropService.prototype.injector;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TruDragAndDropModule = /** @class */ (function () {
    function TruDragAndDropModule() {
    }
    TruDragAndDropModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [DragAndDropComponent],
                    imports: [
                        CommonModule,
                    ],
                    providers: [Dragndrop],
                    exports: [DragAndDropComponent],
                    entryComponents: [DragAndDropComponent]
                },] }
    ];
    return TruDragAndDropModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template D
 */
var  /**
 * @template D
 */
AlertConfig = /** @class */ (function () {
    function AlertConfig() {
    }
    return AlertConfig;
}());
if (false) {
    /** @type {?} */
    AlertConfig.prototype.data;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AlertRef = /** @class */ (function () {
    function AlertRef() {
        this.afterclosed = new Subject();
        this.afterClosed = this.afterclosed.asObservable();
    }
    /**
     * @param {?=} result
     * @return {?}
     */
    AlertRef.prototype.close = /**
     * @param {?=} result
     * @return {?}
     */
    function (result) {
        this.afterclosed.next(result);
    };
    return AlertRef;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    AlertRef.prototype.afterclosed;
    /** @type {?} */
    AlertRef.prototype.afterClosed;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TruAlertComponent = /** @class */ (function () {
    function TruAlertComponent(config, ref) {
        this.config = config;
        this.ref = ref;
        this.remove = false;
    }
    /**
     * @return {?}
     */
    TruAlertComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        this.onClose();
    };
    /**
     * @return {?}
     */
    TruAlertComponent.prototype.onClose = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.closeTimeOut = setTimeout((/**
         * @return {?}
         */
        function () {
            _this.animateBeforeClose();
            _this.ref.close(_this.config);
        }), this.config.data.duration);
    };
    /**
     * @return {?}
     */
    TruAlertComponent.prototype.closeOnCLick = /**
     * @return {?}
     */
    function () {
        clearTimeout(this.closeTimeOut);
        this.animateBeforeClose();
        this.ref.close(this.config);
    };
    /**
     * @return {?}
     */
    TruAlertComponent.prototype.animateBeforeClose = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.remove = true;
        /** @type {?} */
        var alerts = document.body.querySelectorAll('ngx-tru-alert');
        setTimeout((/**
         * @return {?}
         */
        function () {
            _this.removeAlert();
            alerts.forEach((/**
             * @param {?} el
             * @return {?}
             */
            function (el) {
                el.style.top = "calc(" + el.style.top + " - 90px";
            }));
        }), 400);
    };
    /**
     * @return {?}
     */
    TruAlertComponent.prototype.removeAlert = /**
     * @return {?}
     */
    function () {
        var _this = this;
        setTimeout((/**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var currentAlert = document.getElementById("" + _this.config.data.index).parentNode;
            currentAlert.parentNode.removeChild(currentAlert);
        }), 200);
    };
    TruAlertComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-tru-alert',
                    template: "<div id=\"{{config.data.index}}\"\n     class=\"tru-alert-contanier show animated fadeInRight\"\n     [ngClass]=\"{\n      fadeOutRight: remove,\n      success: config.data.type == 'success',\n      danger: config.data.type == 'danger',\n      show: config.data.show,\n      info: config.data.type == 'info'\n    }\"\n     (click)=\"closeOnCLick()\"\n>\n  <div class=\"tru-alert-ico\">\n    <span  *ngIf=\"config.data.type == 'danger'\" class=\"danger-alert\">\n    </span>\n    <span class=\"\" *ngIf=\"config.data.type == 'success'\" class=\"success-alert\"> \n     \n    </span>\n    <span class=\"\" *ngIf=\"config.data.type == 'info'\">i</span>\n  </div>\n  <div class=\"tru-alert-text\">\n    <h3>{{ config.data.type }}</h3>\n    <span>\n        {{ config.data.message }}\n      </span>\n  </div>\n</div>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    TruAlertComponent.ctorParameters = function () { return [
        { type: AlertConfig },
        { type: AlertRef }
    ]; };
    return TruAlertComponent;
}());
if (false) {
    /** @type {?} */
    TruAlertComponent.prototype.closeTimeOut;
    /** @type {?} */
    TruAlertComponent.prototype.remove;
    /** @type {?} */
    TruAlertComponent.prototype.config;
    /**
     * @type {?}
     * @private
     */
    TruAlertComponent.prototype.ref;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TruAlertModule = /** @class */ (function () {
    function TruAlertModule() {
    }
    TruAlertModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule
                    ],
                    declarations: [TruAlertComponent],
                    providers: [AlertConfig],
                    entryComponents: [TruAlertComponent],
                },] }
    ];
    return TruAlertModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var AlertInjector = /** @class */ (function () {
    function AlertInjector(parentInjector, additionalTokens) {
        this.parentInjector = parentInjector;
        this.additionalTokens = additionalTokens;
    }
    /**
     * @param {?} token
     * @param {?=} notFoundValue
     * @param {?=} flags
     * @return {?}
     */
    AlertInjector.prototype.get = /**
     * @param {?} token
     * @param {?=} notFoundValue
     * @param {?=} flags
     * @return {?}
     */
    function (token, notFoundValue, flags) {
        /** @type {?} */
        var value = this.additionalTokens.get(token);
        if (value) {
            return value;
        }
        return this.parentInjector.get(token, notFoundValue);
    };
    return AlertInjector;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    AlertInjector.prototype.parentInjector;
    /**
     * @type {?}
     * @private
     */
    AlertInjector.prototype.additionalTokens;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TruAlertService = /** @class */ (function () {
    function TruAlertService(componentFactoryResolver, appRef, injector) {
        this.componentFactoryResolver = componentFactoryResolver;
        this.appRef = appRef;
        this.injector = injector;
        this.addedAlerts = [];
    }
    /**
     * @param {?=} alertConfig
     * @return {?}
     */
    TruAlertService.prototype.appendAlertComponentToBody = /**
     * @param {?=} alertConfig
     * @return {?}
     */
    function (alertConfig) {
        var _this = this;
        /** @type {?} */
        var map = new WeakMap();
        map.set(AlertConfig, alertConfig);
        /** @type {?} */
        var alertRef = new AlertRef();
        map.set(AlertRef, alertRef);
        /** @type {?} */
        var sub = alertRef.afterClosed.subscribe((/**
         * @return {?}
         */
        function () {
            _this.removeAlertComponentFromBody();
        }));
        /** @type {?} */
        var componentFactory = this.componentFactoryResolver.resolveComponentFactory(TruAlertComponent);
        /** @type {?} */
        var componentRef = componentFactory.create(new AlertInjector(this.injector, map));
        this.appRef.attachView(componentRef.hostView);
        /** @type {?} */
        var domElem = (/** @type {?} */ (((/** @type {?} */ (componentRef.hostView))).rootNodes[0]));
        /** @type {?} */
        var currentMArgin = this.addedAlerts.length * 90;
        /** @type {?} */
        var marginTop = currentMArgin.toString();
        domElem.style.top = marginTop + 'px';
        document.body.appendChild(domElem);
        this.alertComponentRef = componentRef;
        this.addedAlerts.push(this.alertComponentRef);
    };
    /**
     * @private
     * @return {?}
     */
    TruAlertService.prototype.removeAlertComponentFromBody = /**
     * @private
     * @return {?}
     */
    function () {
        this.anotherClear();
    };
    /**
     * @return {?}
     */
    TruAlertService.prototype.anotherClear = /**
     * @return {?}
     */
    function () {
        var _this = this;
        // for adjusting the top margin for each alert
        this.addedAlerts.forEach((/**
         * @param {?} viewRef
         * @param {?} i
         * @return {?}
         */
        function (viewRef, i) {
            _this.addedAlerts = _this.addedAlerts.slice(i, 1);
        }));
    };
    /**
     * @param {?} Message
     * @param {?=} duration
     * @return {?}
     */
    TruAlertService.prototype.openSuccess = /**
     * @param {?} Message
     * @param {?=} duration
     * @return {?}
     */
    function (Message, duration) {
        /** @type {?} */
        var i = document.querySelectorAll('ngx-tru-alert');
        /** @type {?} */
        var config = {
            data: {
                message: Message, type: 'success', show: true, index: 'alert-number-' + i.length, duration: duration || 5000
            }
        };
        this.appendAlertComponentToBody(config);
    };
    /**
     * @param {?} Message
     * @param {?=} duration
     * @return {?}
     */
    TruAlertService.prototype.openDanger = /**
     * @param {?} Message
     * @param {?=} duration
     * @return {?}
     */
    function (Message, duration) {
        /** @type {?} */
        var i = document.querySelectorAll('ngx-tru-alert');
        /** @type {?} */
        var config = {
            data: {
                message: Message, type: 'danger', show: true, index: 'alert-number-' + i.length, duration: duration || 5000
            }
        };
        this.appendAlertComponentToBody(config);
    };
    /**
     * @param {?} Message
     * @param {?=} duration
     * @return {?}
     */
    TruAlertService.prototype.openInfo = /**
     * @param {?} Message
     * @param {?=} duration
     * @return {?}
     */
    function (Message, duration) {
        /** @type {?} */
        var i = document.querySelectorAll('ngx-tru-alert');
        /** @type {?} */
        var config = {
            data: {
                message: Message, type: 'info', show: true, index: 'alert-number-' + i.length, duration: duration || 5000
            }
        };
        this.appendAlertComponentToBody(config);
    };
    /**
     * @param {?} Message
     * @param {?=} duration
     * @return {?}
     */
    TruAlertService.prototype.openWarning = /**
     * @param {?} Message
     * @param {?=} duration
     * @return {?}
     */
    function (Message, duration) {
        /** @type {?} */
        var i = document.querySelectorAll('ngx-tru-alert');
        /** @type {?} */
        var config = {
            data: {
                message: Message, type: 'warnning', show: true, index: 'alert-number-' + i.length, duration: duration || 5000
            }
        };
        this.appendAlertComponentToBody(config);
    };
    TruAlertService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root',
                },] }
    ];
    /** @nocollapse */
    TruAlertService.ctorParameters = function () { return [
        { type: ComponentFactoryResolver },
        { type: ApplicationRef },
        { type: Injector }
    ]; };
    /** @nocollapse */ TruAlertService.ngInjectableDef = ɵɵdefineInjectable({ factory: function TruAlertService_Factory() { return new TruAlertService(ɵɵinject(ComponentFactoryResolver), ɵɵinject(ApplicationRef), ɵɵinject(INJECTOR)); }, token: TruAlertService, providedIn: "root" });
    return TruAlertService;
}());
if (false) {
    /** @type {?} */
    TruAlertService.prototype.alertComponentRef;
    /** @type {?} */
    TruAlertService.prototype.clear;
    /** @type {?} */
    TruAlertService.prototype.addedAlerts;
    /**
     * @type {?}
     * @private
     */
    TruAlertService.prototype.componentFactoryResolver;
    /**
     * @type {?}
     * @private
     */
    TruAlertService.prototype.appRef;
    /**
     * @type {?}
     * @private
     */
    TruAlertService.prototype.injector;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TruColorPickerComponent = /** @class */ (function () {
    function TruColorPickerComponent() {
        this.color = '#ffffff';
        this.selectedColor = new EventEmitter();
    }
    /**
     * @return {?}
     */
    TruColorPickerComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @param {?} ev
     * @return {?}
     */
    TruColorPickerComponent.prototype.getDate = /**
     * @param {?} ev
     * @return {?}
     */
    function (ev) {
        this.color = ev;
        this.selectedColor.emit(this.color);
    };
    /**
     * @param {?} event
     * @return {?}
     */
    TruColorPickerComponent.prototype.changeSelectedColor = /**
     * @param {?} event
     * @return {?}
     */
    function (event) {
        this.color = event;
    };
    TruColorPickerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-tru-color-picker',
                    template: "<div class=\"input-group color-picker-group\">\n  <input type=\"text\" [(ngModel)]=\"color\" class=\"form-control colorpicker-input with-append\" placeholder=\"{{color}}\" [value]=\"color\" />\n  <div class=\"input-group-append\">\n    <button class=\"colorpicker-button\"  [colorPicker]=\"color\"\n            [style.background]=\"color\" (colorPickerChange)=\"getDate($event)\"></button>\n  </div>\n</div>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    TruColorPickerComponent.ctorParameters = function () { return []; };
    TruColorPickerComponent.propDecorators = {
        color: [{ type: Input }],
        selectedColor: [{ type: Output }]
    };
    return TruColorPickerComponent;
}());
if (false) {
    /** @type {?} */
    TruColorPickerComponent.prototype.color;
    /** @type {?} */
    TruColorPickerComponent.prototype.selectedColor;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TruColorPickerModule = /** @class */ (function () {
    function TruColorPickerModule() {
    }
    TruColorPickerModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [TruColorPickerComponent],
                    imports: [
                        CommonModule,
                        ColorPickerModule,
                        FormsModule
                    ],
                    exports: [TruColorPickerComponent],
                    entryComponents: [TruColorPickerComponent]
                },] }
    ];
    return TruColorPickerModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SidenavComponent = /** @class */ (function () {
    function SidenavComponent() {
    }
    /**
     * @return {?}
     */
    SidenavComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    SidenavComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-tru-sidenav',
                    template: "<div class=\"sidebar-wrapper\">\n  <ul>\n    <ng-content></ng-content>\n  </ul>\n<ngx-tru-sidenav-footer>\n  <ng-content select=\"[footer]\"></ng-content>\n</ngx-tru-sidenav-footer>\n</div>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    SidenavComponent.ctorParameters = function () { return []; };
    return SidenavComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SidenavItemComponent = /** @class */ (function () {
    function SidenavItemComponent() {
    }
    /**
     * @return {?}
     */
    SidenavItemComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    SidenavItemComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-tru-sidenav-item',
                    template: "<li class=\"sidebar-item\">\n  <ng-content></ng-content>\n</li>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    SidenavItemComponent.ctorParameters = function () { return []; };
    return SidenavItemComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SidenavFooterComponent = /** @class */ (function () {
    function SidenavFooterComponent() {
    }
    /**
     * @return {?}
     */
    SidenavFooterComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    SidenavFooterComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-tru-sidenav-footer',
                    template: "<div class=\"sidebar-footer\">\n<ng-content></ng-content>\n</div>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    SidenavFooterComponent.ctorParameters = function () { return []; };
    return SidenavFooterComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TruSidenavModule = /** @class */ (function () {
    function TruSidenavModule() {
    }
    TruSidenavModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [SidenavComponent, SidenavItemComponent, SidenavFooterComponent],
                    imports: [
                        CommonModule,
                        RouterModule
                    ],
                    exports: [SidenavComponent, SidenavItemComponent, SidenavFooterComponent],
                    entryComponents: [SidenavComponent, SidenavItemComponent, SidenavFooterComponent]
                },] }
    ];
    return TruSidenavModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TabComponent = /** @class */ (function () {
    function TabComponent() {
        this.active = false;
        this.isCloseable = false;
    }
    /**
     * @return {?}
     */
    TabComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    TabComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-tru-tab',
                    template: "<div [hidden]=\"!active\" class=\"pane\">\n  <ng-content></ng-content>\n  <ng-container *ngIf=\"template\"\n                [ngTemplateOutlet]=\"template\"\n                [ngTemplateOutletContext]=\"{ data: dataContext }\"\n  >\n  </ng-container>\n</div>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    TabComponent.ctorParameters = function () { return []; };
    TabComponent.propDecorators = {
        title: [{ type: Input, args: ['tabTitle',] }],
        active: [{ type: Input }],
        isCloseable: [{ type: Input }],
        template: [{ type: Input }],
        dataContext: [{ type: Input }]
    };
    return TabComponent;
}());
if (false) {
    /** @type {?} */
    TabComponent.prototype.title;
    /** @type {?} */
    TabComponent.prototype.active;
    /** @type {?} */
    TabComponent.prototype.isCloseable;
    /** @type {?} */
    TabComponent.prototype.template;
    /** @type {?} */
    TabComponent.prototype.dataContext;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TabsDirective = /** @class */ (function () {
    function TabsDirective(viewContainer) {
        this.viewContainer = viewContainer;
    }
    TabsDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[ngxTruTabs]'
                },] }
    ];
    /** @nocollapse */
    TabsDirective.ctorParameters = function () { return [
        { type: ViewContainerRef }
    ]; };
    return TabsDirective;
}());
if (false) {
    /** @type {?} */
    TabsDirective.prototype.viewContainer;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TabsComponent = /** @class */ (function () {
    /*
      Alternative approach of using an anchor directive
      would be to simply get hold of a template variable
      as follows
    */
    // @ViewChild('container', {read: ViewContainerRef}) dynamicTabPlaceholder;
    function TabsComponent(componentFactoryResolver) {
        this.componentFactoryResolver = componentFactoryResolver;
        this.dynamicTabs = [];
    }
    // contentChildren are set
    // contentChildren are set
    /**
     * @return {?}
     */
    TabsComponent.prototype.ngAfterContentInit = 
    // contentChildren are set
    /**
     * @return {?}
     */
    function () {
        // get all active tabs
        /** @type {?} */
        var activeTabs = this.tabs.filter((/**
         * @param {?} tab
         * @return {?}
         */
        function (tab) { return tab.active; }));
        // if there is no active tab set, activate the first
        if (activeTabs.length === 0) {
            this.selectTab(this.tabs.first);
        }
    };
    /**
     * @param {?} title
     * @param {?} template
     * @param {?} data
     * @param {?=} isCloseable
     * @return {?}
     */
    TabsComponent.prototype.openTab = /**
     * @param {?} title
     * @param {?} template
     * @param {?} data
     * @param {?=} isCloseable
     * @return {?}
     */
    function (title, template, data, isCloseable) {
        if (isCloseable === void 0) { isCloseable = false; }
        // get a component factory for our TabComponent
        /** @type {?} */
        var componentFactory = this.componentFactoryResolver.resolveComponentFactory(TabComponent);
        // fetch the view container reference from our anchor directive
        /** @type {?} */
        var viewContainerRef = this.dynamicTabPlaceholder.viewContainer;
        // alternatively...
        // let viewContainerRef = this.dynamicTabPlaceholder;
        // create a component instance
        /** @type {?} */
        var componentRef = viewContainerRef.createComponent(componentFactory);
        // set the according properties on our component instance
        /** @type {?} */
        var instance = (/** @type {?} */ (componentRef.instance));
        instance.title = title;
        instance.template = template;
        instance.dataContext = data;
        instance.isCloseable = isCloseable;
        // remember the dynamic component for rendering the
        // tab navigation headers
        this.dynamicTabs.push((/** @type {?} */ (componentRef.instance)));
        // set it active
        this.selectTab(this.dynamicTabs[this.dynamicTabs.length - 1]);
    };
    /**
     * @param {?} tab
     * @return {?}
     */
    TabsComponent.prototype.selectTab = /**
     * @param {?} tab
     * @return {?}
     */
    function (tab) {
        // deactivate all tabs
        this.tabs.toArray().forEach((/**
         * @param {?} singleTab
         * @return {?}
         */
        function (singleTab) { return (singleTab.active = false); }));
        this.dynamicTabs.forEach((/**
         * @param {?} singleTab
         * @return {?}
         */
        function (singleTab) { return (singleTab.active = false); }));
        // activate the tab the user has clicked on.
        tab.active = true;
    };
    /**
     * @param {?} tab
     * @return {?}
     */
    TabsComponent.prototype.closeTab = /**
     * @param {?} tab
     * @return {?}
     */
    function (tab) {
        for (var i = 0; i < this.dynamicTabs.length; i++) {
            if (this.dynamicTabs[i] === tab) {
                // remove the tab from our array
                this.dynamicTabs.splice(i, 1);
                // destroy our dynamically created component again
                /** @type {?} */
                var viewContainerRef = this.dynamicTabPlaceholder.viewContainer;
                // let viewContainerRef = this.dynamicTabPlaceholder;
                viewContainerRef.remove(i);
                // set tab index to 1st one
                this.selectTab(this.tabs.first);
                break;
            }
        }
    };
    /**
     * @return {?}
     */
    TabsComponent.prototype.closeActiveTab = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var activeTabs = this.dynamicTabs.filter((/**
         * @param {?} tab
         * @return {?}
         */
        function (tab) { return tab.active; }));
        if (activeTabs.length > 0) {
            // close the 1st active tab (should only be one at a time)
            this.closeTab(activeTabs[0]);
        }
    };
    TabsComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-tru-tabs',
                    template: "<ul class=\"nav nav-tabs\">\n  <li class=\"nav-link\" *ngFor=\"let tab of tabs\" (click)=\"selectTab(tab)\" [class.active]=\"tab.active\">\n    <span>{{tab.title}}</span>\n  </li>\n  <!-- dynamic tabs -->\n  <li class=\"nav-link\" *ngFor=\"let tab of dynamicTabs\" (click)=\"selectTab(tab)\" [class.active]=\"tab.active\">\n    <span >{{tab.title}} <span class=\"tab-close\" *ngIf=\"tab.isCloseable\" (click)=\"closeTab(tab)\">x</span></span>\n  </li>\n</ul>\n<ng-content></ng-content>\n<ng-template ngxTruTabs #container></ng-template>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    TabsComponent.ctorParameters = function () { return [
        { type: ComponentFactoryResolver }
    ]; };
    TabsComponent.propDecorators = {
        tabs: [{ type: ContentChildren, args: [TabComponent,] }],
        dynamicTabPlaceholder: [{ type: ViewChild, args: [TabsDirective, { static: false },] }]
    };
    return TabsComponent;
}());
if (false) {
    /** @type {?} */
    TabsComponent.prototype.dynamicTabs;
    /** @type {?} */
    TabsComponent.prototype.tabs;
    /** @type {?} */
    TabsComponent.prototype.dynamicTabPlaceholder;
    /**
     * @type {?}
     * @private
     */
    TabsComponent.prototype.componentFactoryResolver;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TruTabsModule = /** @class */ (function () {
    function TruTabsModule() {
    }
    TruTabsModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [TabComponent, TabsComponent, TabsDirective],
                    imports: [
                        CommonModule
                    ],
                    exports: [TabComponent, TabsComponent, TabsDirective],
                    entryComponents: [TabComponent]
                },] }
    ];
    return TruTabsModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DropdownComponent = /** @class */ (function () {
    function DropdownComponent() {
        this.value = 'toggle';
        this.type = 'button';
    }
    /**
     * @return {?}
     */
    DropdownComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    DropdownComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-tru-dropdown',
                    template: "    <div ngbDropdown class=\"d-inline-block\">\n        <ng-content select=\"[input]\"></ng-content>\n      <input [type]=\"type\" [value]=\"value\" class=\"btn btn-link text-center\" ngbDropdownToggle />\n      <div ngbDropdownMenu>\n        <ng-content></ng-content>\n        </div>\n    </div>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    DropdownComponent.ctorParameters = function () { return []; };
    DropdownComponent.propDecorators = {
        value: [{ type: Input }],
        type: [{ type: Input }]
    };
    return DropdownComponent;
}());
if (false) {
    /** @type {?} */
    DropdownComponent.prototype.value;
    /** @type {?} */
    DropdownComponent.prototype.type;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DropdownItemComponent = /** @class */ (function () {
    function DropdownItemComponent() {
    }
    /**
     * @return {?}
     */
    DropdownItemComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    DropdownItemComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-tru-dropdown-item',
                    template: "<a class=\"dropdown-item\">\n<ng-content></ng-content>\n</a>",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    DropdownItemComponent.ctorParameters = function () { return []; };
    return DropdownItemComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TruDropdownModule = /** @class */ (function () {
    function TruDropdownModule() {
    }
    TruDropdownModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [DropdownComponent, DropdownItemComponent],
                    imports: [
                        CommonModule,
                        NgbModule,
                        NgbDropdownModule
                    ],
                    exports: [DropdownComponent, DropdownItemComponent],
                    entryComponents: [DropdownComponent, DropdownItemComponent]
                },] }
    ];
    return TruDropdownModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TruVerticalNavbarComponent = /** @class */ (function () {
    function TruVerticalNavbarComponent() {
    }
    /**
     * @return {?}
     */
    TruVerticalNavbarComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    TruVerticalNavbarComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-tru-vertical-navbar',
                    template: "<div class=\"p-2 tru-vertical-navbar\">\n  <ul class=\"list-group\">\n      <ng-content></ng-content>\n    </ul>\n</div>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    TruVerticalNavbarComponent.ctorParameters = function () { return []; };
    return TruVerticalNavbarComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TruVerticalNavbarItemComponent = /** @class */ (function () {
    function TruVerticalNavbarItemComponent() {
    }
    /**
     * @return {?}
     */
    TruVerticalNavbarItemComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    TruVerticalNavbarItemComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-tru-vertical-navbar-item',
                    template: "<li class=\"list-group-item list-group-item-text\" >\n  <ng-content></ng-content>\n</li>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    TruVerticalNavbarItemComponent.ctorParameters = function () { return []; };
    return TruVerticalNavbarItemComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TruVerticalNavbarModule = /** @class */ (function () {
    function TruVerticalNavbarModule() {
    }
    TruVerticalNavbarModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [TruVerticalNavbarComponent, TruVerticalNavbarItemComponent],
                    imports: [
                        CommonModule
                    ],
                    exports: [TruVerticalNavbarComponent, TruVerticalNavbarItemComponent],
                    entryComponents: [TruVerticalNavbarComponent, TruVerticalNavbarItemComponent]
                },] }
    ];
    return TruVerticalNavbarModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var InsertionDirective = /** @class */ (function () {
    function InsertionDirective(viewContainerRef) {
        this.viewContainerRef = viewContainerRef;
    }
    InsertionDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[ngxTruInsertion]'
                },] }
    ];
    /** @nocollapse */
    InsertionDirective.ctorParameters = function () { return [
        { type: ViewContainerRef }
    ]; };
    return InsertionDirective;
}());
if (false) {
    /** @type {?} */
    InsertionDirective.prototype.viewContainerRef;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @template D
 */
var  /**
 * @template D
 */
ModalConfig = /** @class */ (function () {
    function ModalConfig() {
    }
    return ModalConfig;
}());
if (false) {
    /** @type {?} */
    ModalConfig.prototype.data;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ModalRef = /** @class */ (function () {
    function ModalRef() {
        this.afterclosed = new Subject();
        this.afterClosed = this.afterclosed.asObservable();
    }
    /**
     * @param {?=} result
     * @return {?}
     */
    ModalRef.prototype.close = /**
     * @param {?=} result
     * @return {?}
     */
    function (result) {
        this.afterclosed.next(result);
    };
    return ModalRef;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    ModalRef.prototype.afterclosed;
    /** @type {?} */
    ModalRef.prototype.afterClosed;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TruModalComponent = /** @class */ (function () {
    function TruModalComponent(componentFactoryResolver, cd, modalref, modalconfig) {
        this.componentFactoryResolver = componentFactoryResolver;
        this.cd = cd;
        this.modalref = modalref;
        this.modalconfig = modalconfig;
    }
    /**
     * @return {?}
     */
    TruModalComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        this.loadChildComponent(this.childComponentType);
        this.cd.detectChanges();
    };
    /**
     * @return {?}
     */
    TruModalComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        if (this.componentRef) {
            this.componentRef.destroy();
        }
    };
    /**
     * @return {?}
     */
    TruModalComponent.prototype.onOverlayClicked = /**
     * @return {?}
     */
    function () {
        this.modalref.close(this.modalconfig.data);
    };
    /**
     * @param {?} evt
     * @return {?}
     */
    TruModalComponent.prototype.onDialogClicked = /**
     * @param {?} evt
     * @return {?}
     */
    function (evt) {
        evt.stopPropagation();
    };
    /**
     * @param {?} componentType
     * @return {?}
     */
    TruModalComponent.prototype.loadChildComponent = /**
     * @param {?} componentType
     * @return {?}
     */
    function (componentType) {
        if (componentType instanceof TemplateRef) {
            /** @type {?} */
            var viewRef = componentType.createEmbeddedView(null);
            /** @type {?} */
            var viewContainerRef = this.insertionPoint.viewContainerRef.insert(viewRef);
            return viewContainerRef;
        }
        else {
            /** @type {?} */
            var componentFactory = this.componentFactoryResolver.resolveComponentFactory(componentType);
            /** @type {?} */
            var viewContainerRef = this.insertionPoint.viewContainerRef;
            viewContainerRef.clear();
            this.componentRef = viewContainerRef.createComponent(componentFactory);
        }
    };
    TruModalComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-tru-modal',
                    template: "<div\n  class=\"modal animated fadeIn\"\n  style=\"display: block; padding-right: 19px;\"\n  tabindex=\"-1\"\n  role=\"dialog\"\n  aria-labelledby=\"exampleModalLabel\"\n  aria-hidden=\"true\"\n  (click)=\"onDialogClicked($event)\"\n>\n  <ng-template ngxTruInsertion></ng-template>\n</div>\n<div class=\"modal-backdrop fade show\" (click)=\"onOverlayClicked()\"></div>\n",
                    styles: [".modal{transform:translateX(-50%);left:50%}"]
                }] }
    ];
    /** @nocollapse */
    TruModalComponent.ctorParameters = function () { return [
        { type: ComponentFactoryResolver },
        { type: ChangeDetectorRef },
        { type: ModalRef },
        { type: ModalConfig }
    ]; };
    TruModalComponent.propDecorators = {
        insertionPoint: [{ type: ViewChild, args: [InsertionDirective, { static: false },] }]
    };
    return TruModalComponent;
}());
if (false) {
    /** @type {?} */
    TruModalComponent.prototype.childComponentType;
    /** @type {?} */
    TruModalComponent.prototype.componentRef;
    /** @type {?} */
    TruModalComponent.prototype.data;
    /** @type {?} */
    TruModalComponent.prototype.insertionPoint;
    /**
     * @type {?}
     * @private
     */
    TruModalComponent.prototype.componentFactoryResolver;
    /**
     * @type {?}
     * @private
     */
    TruModalComponent.prototype.cd;
    /** @type {?} */
    TruModalComponent.prototype.modalref;
    /** @type {?} */
    TruModalComponent.prototype.modalconfig;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var DialogComponent = /** @class */ (function () {
    function DialogComponent(config, ref) {
        this.config = config;
        this.ref = ref;
    }
    //
    //
    /**
     * @return {?}
     */
    DialogComponent.prototype.ngOnInit = 
    //
    /**
     * @return {?}
     */
    function () {
    };
    /**
     * @return {?}
     */
    DialogComponent.prototype.close = /**
     * @return {?}
     */
    function () {
        this.ref.close({ status: true });
    };
    DialogComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-tru-dialog',
                    template: "<div class=\"modal-dialog\">\n  <div class=\"modal-content\">\n    <div class=\"modal-header\">\n      <h5 class=\"modal-title\">{{config.data.title}}</h5>\n    </div>\n    <div class=\"modal-body p-0\">\n      <p>\n      {{config.data.content}}\n      </p>\n    </div>\n    <div class=\"modal-footer\">\n      <button type=\"button\" class=\"btn btn-round btn-round-secondary\" data-dismiss=\"modal\" (click)=\"close()\">{{config.data.buton || 'ok'}}</button>\n    </div>\n  </div>\n</div>\n",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    DialogComponent.ctorParameters = function () { return [
        { type: ModalConfig },
        { type: ModalRef }
    ]; };
    return DialogComponent;
}());
if (false) {
    /** @type {?} */
    DialogComponent.prototype.config;
    /** @type {?} */
    DialogComponent.prototype.ref;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TruModalModule = /** @class */ (function () {
    function TruModalModule() {
    }
    TruModalModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [TruModalComponent, InsertionDirective, DialogComponent],
                    imports: [
                        CommonModule,
                    ],
                    providers: [ModalConfig],
                    entryComponents: [TruModalComponent, DialogComponent],
                },] }
    ];
    return TruModalModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ModalInjector = /** @class */ (function () {
    function ModalInjector(parentInjector, additionalTokens) {
        this.parentInjector = parentInjector;
        this.additionalTokens = additionalTokens;
    }
    /**
     * @param {?} token
     * @param {?=} notFoundValue
     * @param {?=} flags
     * @return {?}
     */
    ModalInjector.prototype.get = /**
     * @param {?} token
     * @param {?=} notFoundValue
     * @param {?=} flags
     * @return {?}
     */
    function (token, notFoundValue, flags) {
        /** @type {?} */
        var value = this.additionalTokens.get(token);
        if (value) {
            return value;
        }
        return this.parentInjector.get(token, notFoundValue);
    };
    return ModalInjector;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    ModalInjector.prototype.parentInjector;
    /**
     * @type {?}
     * @private
     */
    ModalInjector.prototype.additionalTokens;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TruModalService = /** @class */ (function () {
    function TruModalService(componentFactoryResolver, appRef, injector) {
        this.componentFactoryResolver = componentFactoryResolver;
        this.appRef = appRef;
        this.injector = injector;
        this.components = [];
    }
    /**
     * @private
     * @param {?=} modalconfig
     * @return {?}
     */
    TruModalService.prototype.appendModalComponentToBody = /**
     * @private
     * @param {?=} modalconfig
     * @return {?}
     */
    function (modalconfig) {
        var _this = this;
        /** @type {?} */
        var map = new WeakMap();
        map.set(ModalConfig, modalconfig);
        /** @type {?} */
        var modalRef = new ModalRef();
        map.set(ModalRef, modalRef);
        /** @type {?} */
        var sub = modalRef.afterClosed.subscribe((/**
         * @return {?}
         */
        function () {
            _this.removeModalComponentFromBody();
            sub.unsubscribe();
        }));
        /** @type {?} */
        var componentFactory = this.componentFactoryResolver.resolveComponentFactory(TruModalComponent);
        /** @type {?} */
        var componentRef = componentFactory.create(new ModalInjector(this.injector, map));
        this.appRef.attachView(componentRef.hostView);
        /** @type {?} */
        var domElem = (/** @type {?} */ (((/** @type {?} */ (componentRef.hostView))).rootNodes[0]));
        document.body.appendChild(domElem);
        this.modalComponentRef = componentRef;
        return modalRef;
    };
    /**
     * @private
     * @return {?}
     */
    TruModalService.prototype.removeModalComponentFromBody = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var lastModal = document.body.querySelectorAll('ngx-tru-modal');
        if (lastModal.length > 0) {
            lastModal[lastModal.length - 1].remove();
        }
        else {
            lastModal[0].remove();
        }
        this.appRef.detachView(this.modalComponentRef.hostView);
        this.modalComponentRef.destroy();
    };
    /**
     * @param {?} componentType
     * @param {?} modalconfig
     * @return {?}
     */
    TruModalService.prototype.openModal = /**
     * @param {?} componentType
     * @param {?} modalconfig
     * @return {?}
     */
    function (componentType, modalconfig) {
        /** @type {?} */
        var modal = this.appendModalComponentToBody(modalconfig);
        this.components.push(componentType);
        // if(componentType instanceof TemplateRef){
        //   console.log('here');
        //   const viewRef = componentType.createEmbeddedView(null);
        //   this.modalComponentRef.instance.childComponentType = viewRef;
        //   return modal;
        // } else {
        this.modalComponentRef.instance.childComponentType = componentType;
        return modal;
    };
    /**
     * @param {?} title
     * @param {?} content
     * @param {?=} button
     * @return {?}
     */
    TruModalService.prototype.openDialog = /**
     * @param {?} title
     * @param {?} content
     * @param {?=} button
     * @return {?}
     */
    function (title, content, button) {
        /** @type {?} */
        var modalconfig = { data: {
                title: title,
                content: content,
                button: button || 'ok'
            }
        };
        /** @type {?} */
        var modal = this.appendModalComponentToBody(modalconfig);
        this.components.push(DialogComponent);
        this.modalComponentRef.instance.childComponentType = DialogComponent;
        return modal;
    };
    /**
     * @return {?}
     */
    TruModalService.prototype.closeModal = /**
     * @return {?}
     */
    function () {
        // Find the component
        // const component = this.components.find((comp) => comp === componentType);
        // const componentIndex = this.components.indexOf(component);
        // if (componentIndex !== -1) {
        //   // Remove component from both view and array
        //   this.components.splice(componentIndex, 1);
        //   this.removeModalComponentFromBody();
        // }
        this.removeModalComponentFromBody();
    };
    TruModalService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    TruModalService.ctorParameters = function () { return [
        { type: ComponentFactoryResolver },
        { type: ApplicationRef },
        { type: Injector }
    ]; };
    /** @nocollapse */ TruModalService.ngInjectableDef = ɵɵdefineInjectable({ factory: function TruModalService_Factory() { return new TruModalService(ɵɵinject(ComponentFactoryResolver), ɵɵinject(ApplicationRef), ɵɵinject(INJECTOR)); }, token: TruModalService, providedIn: "root" });
    return TruModalService;
}());
if (false) {
    /** @type {?} */
    TruModalService.prototype.modalComponentRef;
    /** @type {?} */
    TruModalService.prototype.components;
    /**
     * @type {?}
     * @private
     */
    TruModalService.prototype.componentFactoryResolver;
    /**
     * @type {?}
     * @private
     */
    TruModalService.prototype.appRef;
    /**
     * @type {?}
     * @private
     */
    TruModalService.prototype.injector;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SidebarContainerComponent = /** @class */ (function () {
    function SidebarContainerComponent() {
        this.close = false;
    }
    /**
     * @return {?}
     */
    SidebarContainerComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @param {?} ev
     * @return {?}
     */
    SidebarContainerComponent.prototype.isClosed = /**
     * @param {?} ev
     * @return {?}
     */
    function (ev) {
        this.close = ev;
    };
    SidebarContainerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-tru-sidebar-container',
                    template: "<div class=\"right-sidebar-conhtainer animated fadeInRight\" [ngClass]=\"{'fadeOutRight': close}\">\n    <ngx-tru-sidebar-header [close]=\"close\" (isCloesed)=\"isClosed($event)\">\n    <ng-content select=\"header\"></ng-content>\n</ngx-tru-sidebar-header>\n<ngx-tru-sidebar-toolbar>\n    <ng-content select=\"toolbar\"></ng-content>\n</ngx-tru-sidebar-toolbar>\n<ngx-tru-sidebar-body>\n    <ng-content select=\"body\"></ng-content>\n</ngx-tru-sidebar-body>\n</div>",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    SidebarContainerComponent.ctorParameters = function () { return []; };
    return SidebarContainerComponent;
}());
if (false) {
    /** @type {?} */
    SidebarContainerComponent.prototype.close;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SidebarService = /** @class */ (function () {
    function SidebarService(resolver, applicationRef, injector, document) {
        this.resolver = resolver;
        this.applicationRef = applicationRef;
        this.injector = injector;
        this.document = document;
        this.close = new BehaviorSubject(false);
        this.data = new BehaviorSubject({});
        this.alreadyExist = false;
    }
    /**
     * @param {?} data
     * @return {?}
     */
    SidebarService.prototype.setData = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        this.data.next(data);
    };
    /**
     * @return {?}
     */
    SidebarService.prototype.toggleSidebar = /**
     * @return {?}
     */
    function () {
        /** @type {?} */
        var currentStatus = this.close.getValue();
        this.close.next(!currentStatus);
        return this.close.getValue();
    };
    /**
     * @template T
     * @param {?} content
     * @return {?}
     */
    SidebarService.prototype.open = /**
     * @template T
     * @param {?} content
     * @return {?}
     */
    function (content) {
        var _this = this;
        this.toggleSidebar();
        this.close.subscribe((/**
         * @param {?} res
         * @return {?}
         */
        function (res) {
            _this.alreadyExist = res;
            res ? _this.alreadyExist = true : _this.closeSidebar();
        }));
        if (this.alreadyExist) {
            /** @type {?} */
            var factory = this.resolver.resolveComponentFactory(SidebarContainerComponent);
            /** @type {?} */
            var ngContent = this.resolveNgContent(content);
            this.componentRef = factory.create(this.injector, ngContent);
            this.applicationRef.attachView(this.componentRef.hostView);
            this.componentRef.hostView.detectChanges();
            var nativeElement = this.componentRef.location.nativeElement;
            this.document.body.appendChild(nativeElement);
        }
    };
    /**
     * @template T
     * @param {?} content
     * @return {?}
     */
    SidebarService.prototype.resolveNgContent = /**
     * @template T
     * @param {?} content
     * @return {?}
     */
    function (content) {
        if (content instanceof TemplateRef) {
            /** @type {?} */
            var viewRef = content.createEmbeddedView(null);
            this.applicationRef.attachView(viewRef);
            /** @type {?} */
            var spread_1 = [];
            viewRef.rootNodes.forEach((/**
             * @param {?} node
             * @return {?}
             */
            function (node) {
                spread_1.push([node]);
            }));
            return spread_1;
        }
        /** @type {?} */
        var factory = this.resolver.resolveComponentFactory(content);
        /** @type {?} */
        var componentRef = factory.create(this.injector);
        return [[componentRef.location.nativeElement]];
    };
    /**
     * @return {?}
     */
    SidebarService.prototype.closeSidebar = /**
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var sidebar = document.getElementsByClassName('right-sidebar-conhtainer');
        sidebar.item(0).className += ' fadeOutRight ';
        setTimeout((/**
         * @return {?}
         */
        function () { _this.componentRef.destroy(); }), 1100);
    };
    SidebarService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    SidebarService.ctorParameters = function () { return [
        { type: ComponentFactoryResolver },
        { type: ApplicationRef },
        { type: Injector },
        { type: Document, decorators: [{ type: Inject, args: [DOCUMENT,] }] }
    ]; };
    /** @nocollapse */ SidebarService.ngInjectableDef = ɵɵdefineInjectable({ factory: function SidebarService_Factory() { return new SidebarService(ɵɵinject(ComponentFactoryResolver), ɵɵinject(ApplicationRef), ɵɵinject(INJECTOR), ɵɵinject(DOCUMENT)); }, token: SidebarService, providedIn: "root" });
    return SidebarService;
}());
if (false) {
    /** @type {?} */
    SidebarService.prototype.close;
    /** @type {?} */
    SidebarService.prototype.data;
    /** @type {?} */
    SidebarService.prototype.componentRef;
    /** @type {?} */
    SidebarService.prototype.alreadyExist;
    /**
     * @type {?}
     * @private
     */
    SidebarService.prototype.resolver;
    /**
     * @type {?}
     * @private
     */
    SidebarService.prototype.applicationRef;
    /**
     * @type {?}
     * @private
     */
    SidebarService.prototype.injector;
    /**
     * @type {?}
     * @private
     */
    SidebarService.prototype.document;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SidebarHeaderComponent = /** @class */ (function () {
    function SidebarHeaderComponent(sidebarservice) {
        this.sidebarservice = sidebarservice;
        this.close = false;
        this.isCloesed = new EventEmitter();
    }
    /**
     * @return {?}
     */
    SidebarHeaderComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.sidebarservice.close.subscribe((/**
         * @param {?} res
         * @return {?}
         */
        function (res) {
            _this.close = res;
        }));
    };
    /**
     * @return {?}
     */
    SidebarHeaderComponent.prototype.closeSideBar = /**
     * @return {?}
     */
    function () {
        this.close = this.sidebarservice.toggleSidebar();
        this.isCloesed.emit(true);
    };
    SidebarHeaderComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-tru-sidebar-header',
                    template: "<div class=\"right-sidebar-header\">\n    <strong>\n     <ng-content></ng-content>\n    </strong>\n    <a (click)=\"closeSideBar()\"><i class=\"fa fa-times\"></i></a>\n</div>",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    SidebarHeaderComponent.ctorParameters = function () { return [
        { type: SidebarService }
    ]; };
    SidebarHeaderComponent.propDecorators = {
        close: [{ type: Input }],
        isCloesed: [{ type: Output }]
    };
    return SidebarHeaderComponent;
}());
if (false) {
    /** @type {?} */
    SidebarHeaderComponent.prototype.close;
    /** @type {?} */
    SidebarHeaderComponent.prototype.isCloesed;
    /**
     * @type {?}
     * @private
     */
    SidebarHeaderComponent.prototype.sidebarservice;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SidebarToolbarComponent = /** @class */ (function () {
    function SidebarToolbarComponent() {
    }
    /**
     * @return {?}
     */
    SidebarToolbarComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    SidebarToolbarComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-tru-sidebar-toolbar',
                    template: "<div class=\"right-sidebar-toolbar\">\n    <ng-content></ng-content>\n</div>",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    SidebarToolbarComponent.ctorParameters = function () { return []; };
    return SidebarToolbarComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var SidebarBodyComponent = /** @class */ (function () {
    function SidebarBodyComponent() {
    }
    /**
     * @return {?}
     */
    SidebarBodyComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    SidebarBodyComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-tru-sidebar-body',
                    template: "<ng-content></ng-content>",
                    styles: [""]
                }] }
    ];
    /** @nocollapse */
    SidebarBodyComponent.ctorParameters = function () { return []; };
    return SidebarBodyComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TruSidebarModule = /** @class */ (function () {
    function TruSidebarModule() {
    }
    TruSidebarModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [SidebarContainerComponent, SidebarHeaderComponent, SidebarToolbarComponent, SidebarBodyComponent],
                    imports: [
                        CommonModule
                    ],
                    exports: [SidebarContainerComponent, SidebarHeaderComponent, SidebarToolbarComponent, SidebarBodyComponent],
                    entryComponents: [SidebarContainerComponent]
                },] }
    ];
    return TruSidebarModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { DragAndDropService, DragndropRef, ModalConfig, ModalRef, NgxTruUiComponent, NgxTruUiModule, NgxTruUiService, SidebarService, TabComponent, TabsComponent, TabsDirective, TruAlertModule, TruAlertService, TruColorPickerComponent, TruColorPickerModule, TruDatePickerComponent, TruDatePickerModule, TruDragAndDropModule, TruDropdownModule, TruModalModule, TruModalService, TruSidebarModule, TruSidenavModule, TruTabsModule, TruVerticalNavbarModule, DragAndDropComponent as ɵa, Dragndrop as ɵb, TruAlertComponent as ɵc, AlertConfig as ɵd, AlertRef as ɵe, SidenavComponent as ɵf, SidenavItemComponent as ɵg, SidenavFooterComponent as ɵh, DropdownComponent as ɵi, DropdownItemComponent as ɵj, TruVerticalNavbarComponent as ɵk, TruVerticalNavbarItemComponent as ɵl, TruModalComponent as ɵm, InsertionDirective as ɵn, DialogComponent as ɵo, SidebarContainerComponent as ɵp, SidebarHeaderComponent as ɵq, SidebarToolbarComponent as ɵr, SidebarBodyComponent as ɵs };
//# sourceMappingURL=ngx-tru-ui.js.map
