import { ComponentFactoryResolver, ApplicationRef, Injector, ComponentRef } from '@angular/core';
import { AlertConfig } from '../model/tru-alert-config';
import { TruAlertComponent } from '../component/tru-alert.component';
export declare class TruAlertService {
    private componentFactoryResolver;
    private appRef;
    private injector;
    alertComponentRef: ComponentRef<TruAlertComponent>;
    clear: any;
    addedAlerts: any[];
    constructor(componentFactoryResolver: ComponentFactoryResolver, appRef: ApplicationRef, injector: Injector);
    appendAlertComponentToBody(alertConfig?: AlertConfig): void;
    private removeAlertComponentFromBody;
    anotherClear(): void;
    openSuccess(Message: any, duration?: any): void;
    openDanger(Message: any, duration?: any): void;
    openInfo(Message: any, duration?: any): void;
    openWarning(Message: any, duration?: any): void;
}
