import { Injector, Type, InjectionToken, InjectFlags } from '@angular/core';
export declare class ModalInjector {
    private parentInjector;
    private additionalTokens;
    constructor(parentInjector: Injector, additionalTokens: WeakMap<any, any>);
    get<T>(token: Type<T> | InjectionToken<T>, notFoundValue?: T, flags?: InjectFlags): T;
    get(token: any, notFoundValue?: any): any;
}
