import { AfterViewInit, OnDestroy, Type, ComponentRef, ComponentFactoryResolver, ChangeDetectorRef } from '@angular/core';
import { InsertionDirective } from './insertion.directive';
import { ModalConfig } from '../model/modal-config';
import { ModalRef } from './modal-ref';
export declare class TruModalComponent implements AfterViewInit, OnDestroy {
    private componentFactoryResolver;
    private cd;
    modalref: ModalRef;
    modalconfig: ModalConfig;
    childComponentType: Type<any>;
    componentRef: ComponentRef<any>;
    data: any;
    insertionPoint: InsertionDirective;
    constructor(componentFactoryResolver: ComponentFactoryResolver, cd: ChangeDetectorRef, modalref: ModalRef, modalconfig: ModalConfig);
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    onOverlayClicked(): void;
    onDialogClicked(evt: MouseEvent): void;
    loadChildComponent(componentType: Type<any>): import("@angular/core").ViewRef;
}
