import { ComponentFactoryResolver, ApplicationRef, Injector, ComponentRef, Type } from '@angular/core';
import { TruModalComponent } from '../component/tru-modal.component';
import { ModalRef } from '../component/modal-ref';
export declare class TruModalService {
    private componentFactoryResolver;
    private appRef;
    private injector;
    modalComponentRef: ComponentRef<TruModalComponent>;
    components: any[];
    constructor(componentFactoryResolver: ComponentFactoryResolver, appRef: ApplicationRef, injector: Injector);
    private appendModalComponentToBody;
    private removeModalComponentFromBody;
    openModal(componentType: Type<any>, modalconfig: any): ModalRef;
    openDialog(title: string, content: string, button?: any): ModalRef;
    closeModal(): void;
}
