import { QueryList, AfterContentInit, ComponentFactoryResolver } from '@angular/core';
import { TabComponent } from '../tab/tab.component';
import { TabsDirective } from '../tabs.directive';
export declare class TabsComponent implements AfterContentInit {
    private componentFactoryResolver;
    dynamicTabs: TabComponent[];
    tabs: QueryList<TabComponent>;
    dynamicTabPlaceholder: TabsDirective;
    constructor(componentFactoryResolver: ComponentFactoryResolver);
    ngAfterContentInit(): void;
    openTab(title: string, template: any, data: any, isCloseable?: boolean): void;
    selectTab(tab: TabComponent): void;
    closeTab(tab: TabComponent): void;
    closeActiveTab(): void;
}
