import { ComponentFactoryResolver, Injector, TemplateRef, Type, ApplicationRef } from '@angular/core';
import { BehaviorSubject } from 'rxjs';
import { Data } from './data';
export declare type Content<T> = TemplateRef<T> | Type<T>;
export declare class SidebarService {
    private resolver;
    private applicationRef;
    private injector;
    private document;
    close: BehaviorSubject<boolean>;
    data: BehaviorSubject<Data<any>>;
    componentRef: any;
    alreadyExist: boolean;
    constructor(resolver: ComponentFactoryResolver, applicationRef: ApplicationRef, injector: Injector, document: Document);
    setData(data: Data): void;
    toggleSidebar(): boolean;
    open<T>(content: Content<T>): void;
    resolveNgContent<T>(content: Content<T>): any[];
    closeSidebar(): void;
}
